<?php
if (!defined('W2P_BASE_DIR')) {
    die('You should not access this file directly.');
}

//require_once( $AppUI->getSystemClass( 'libmail' ) );
//require_once( $AppUI->getSystemClass( 'w2p' ) );

class CInvoice extends w2p_Core_BaseObject {
	// table 'invoice'
	public $invoice_id = null;
	public $invoice_tag = null;
	public $invoice_project = 0;
	public $invoice_status = 0;
	public $invoice_data = null;
	public $invoice_paid = null;
	public $invoice_creator = null;

	// table 'invoice_task_queue'
	public $invoice_task_queue_id = null;
	public $task_invoice = null;
	public $task_log_id = null;
	public $task_amount = null;

        public function __construct() {
		parent::__construct('invoice', 'invoice_id');
        }

	public function isValid() {
		$baseErrorMsg = get_class($this) . '::store-check failed -';
		if ($this->invoice_id == 0) {
			$this->_error['invoice_id'] = $baseErrorMsg . 'invoice_id is not set';
		}
		return (count($this->_error)) ? false : true;
	}

	public function check() {
		if ($this->task_invoice == NULL || $this->task_invoice == "0") {
			if (!$this->init()) {
				return false;
			}
		}
		if (empty($this->task_amount))
			$this->task_amount = '0';
		return true;
	}

	protected function init() {
		$q = $this->_getQuery();
		$q->addTable('invoice');
		$q->addInsert('invoice_project,invoice_date,invoice_creator',
				$_POST['invoice_project'].','.time().','.$_POST['project_creator'], true);
		if (!$q->exec()) {
			$this->_error['init-invoice'] = db_error();
			return false;
		}
		$this->task_invoice = db_insert_id();
//		$temp_array = mysql_fetch_array(mysql_query("select last_insert_id() from invoice"));
//		$my_last_id = $temp_array['last_insert_id()']; 
//		$this->task_invoice=(int)$my_last_id;
		return true;
	}

	public function load($unused = null, $invoice_id) {
		$q = $this->_getQuery();
		$q->addQuery('*');
		$q->addTable('invoice');
		$q->addWhere('invoice_id =' . (int)$invoice_id);
		$q->loadObject($this, true, false);
	}

	public function store($unused = null) {
		$this->clearErrors();
		if (!$this->check()) {
			$this->_error['store-invoice'] = 'failed store sanity checks';
			return false;
		}
		$q = $this->_getQuery();
		$q->addTable('invoice_task_queue');
		$q->addInsert('task_invoice,task_amount,task_log_id',
			$this->task_invoice.','.$this->task_amount.','.$this->task_log_id, true);
		if (!$q->exec()) {
			$this->_error['store-invoice'] = db_error();
			return false;
		}
		//db_insertObject('invoice_task_queue',$this,'task_queue_id');
		return true;
	}

	public function delete($unused = null) {
		$this->clearErrors();
		$this->_action='deleted';
		$q = $this->_getQuery();
		$q->setDelete('invoice_task_queue');
		$q->addWhere('task_queue_id = ' . $this->_task_queue_id);
		if (!$q->exec()) {
			$this->_error['delete-invoice'] = db_error();
			return false;
		}
		return true;
	}

	public function purge()
	{
		$this->clearErrors();
		$this->_action='purged';
		$q = $this->_getQuery();
		$q->addQuery('invoice_status');
		$q->addTable('invoice');
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		$temp_array= $q->loadList();
		$mystatus=$temp_array[0]["invoice_status"];
		if ($mystatus == 0) 
		{
			$q->clear();	
			$q->setDelete('invoice_task_queue');
			$q->addWhere('task_invoice = ' . $this->task_invoice);
			if (!$q->exec()) {
				$this->_error['purge-invoice'] = db_error();
				return false;
			}
		} 
		else 
		{
			$q->clear();
			$q->addTable('tasks');
			$q->addUpdate('task_invoice', '0');
			$q->addUpdate('task_cost' , '0');
			$q->addWhere('task_invoice = ' . $this->task_invoice);
			if (!$q->exec()) {
				$this->_error['purge-invoice'] = db_error();
				return false;
			}
		}

		$q->clear();
		$q->setDelete('invoice');
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		if (!$q->exec()) {
			$this->_error['purge-invoice'] = db_error();
			return false;
		}
		return true;
	}

	public function change_status($stat)
	{
		$this->clearErrors();
		$this->_action='updated';
		$q = $this->_getQuery();
		$q->addTable('invoice');
		$q->addUpdate('invoice_status', $stat);
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		if (!$q->exec()) {
			$this->_error['status-invoice'] = db_error();
			return false;
		}
		return true;
	}

	public function change_invoice_tag($tag)
	{
		$this->clearErrors();
		$this->_action='updated';
		$q = $this->_getQuery();
		$q->addTable('invoice');
		$q->addUpdate('invoice_tag', $tag);
		$q->addWhere('invoice_id = ' . $this->task_invoice);
		if (!$q->exec()) {
			$this->_error['tag-invoice'] = db_error();
			return false;
		}
		return true;
	}
}
