<?php
if (!defined('W2P_BASE_DIR')) {
    die('You should not access this file directly.');
}
error_reporting(!E_ALL);
$project_id = intval( w2PgetParam( $_GET, "project_id", 0 ) );
$invoice_id = intval( w2PgetParam( $_GET, "invoice_id", 0 ) );
$invoice_to = intval( w2PgetParam( $_GET, "invoice_to", 0 ) );
$tasks = intval( w2PgetParam( $_GET, "tasks", 0 ) );

$invTitlePos    = 650;  // up/down where to begin printing theINVOICE header 
$invToPos       = 600;  // up/down where to print the To: block 
$invToInfoPos   = 570;  // up/down where to print the To: and Info data
$df = $AppUI->getPref('SHDATEFORMAT');

$font_dir = w2PgetConfig( 'root_dir' )."/lib/ezpdf/fonts";
$temp_dir = w2PgetConfig( 'root_dir' )."/files/temp";
$base_url  = w2PgetConfig( 'base_url' );
require( $AppUI->getLibraryClass( 'ezpdf/class.ezpdf' ) );


$landscape = 0;
if ($landscape != 1)
    $pdf = new Cezpdf("letter", "portrait");
else
    $pdf = new Cezpdf("letter", "landscape");


$pdf->ezSetCmMargins( 1, 2, 1.5, 1.5 );
$pdf->selectFont( "$font_dir/Helvetica.afm" );

//================================================
//  Invoice header
//================================================
$logoFontSize    = 20;      // font size for the company name
$addressFontSize = 13;      // font size for the address lines
$phoneFontSize   = 10;      // font size for the phone lines
$justification   = 'center';    // justification can be left, right, center, full
$compRColor      = 0;       // rgb color for the company name
$compGColor      = 0;
$compBColor      = 0;
$textRColor      = 0;       // rgb values for the remaing text
$textGColor      = 0;
$textBColor      = 0;   

//
//  query the database for company info
//
$q = new DBQuery;
$q->addQuery('
		company_name, 
		company_address1, 
		company_address2,
		company_city,
		company_state,
		company_zip,
		company_phone1,
		company_fax');
$q->addTable('companies');
$q->leftJoin('config', 'c', 'company_name = config_value');
$q->addWhere('c.config_name = \'company_name\'');
//$srcComp = $q->loadHash();
db_loadHash($q->prepare(), $srcComp);

//
// Set up and print the header data
//
$pdf->ezImage('/var/www/localhost/htdocs/dotproject3/modules/invoice/images/boone.jpg');
$pdf->setColor($compRColor,$compGColor,$compBColor);
$pdf->ezText($srcComp['company_name'], $logoFontSize,
array('justification' => $justification));
$pdf->setColor($textRColor,$textGColor,$textBColor);
$pdf->ezText($srcComp['company_address1'], $addressFontSize, array('justification' => $justification));

// if the second address line is blank, don't print it
if ($srcComp['company_address2'] != '')
	$pdf->ezText($srcComp['company_address2'], $addressFontSize, array('justification' => $justification));

$pdf->ezText($srcComp['company_city'] . ', ' .
            $srcComp['company_state'] . '   ' .
            $srcComp['company_zip'], $addressFontSize,
array('justification' => $justification));
$pdf->ezText($srcComp['company_phone1'], $phoneFontSize,
array('justification' => $justification));
$pdf->ezText($srcComp['company_fax'], $phoneFontSize,
array('justification' => $justification));
$pdf->ezText('');
$pdf->ezText('');

//================================================
//  Invoice Title
//================================================
$pdf->ezSetY($invTitlePos);
$pdf->setColor(0,0,1);
$pdf->ezText('INVOICE', 18, array('justification' => 'center'));
$pdf->setColor(0,0,0);

//================================================
//  Target company info
//================================================
$pdf->ezSetY($invToPos);
$toFontSize      = 14;      // font size for the "Invoice To" text
$addressFontSize = 12;      // font size for all other "Invoice To" text
$toRColor        = 0;       // rgb color values for the "Invoice To: text
$toGColor        = 0;
$toBColor        = 0;
$textRColor      = 0;       // rgb color values for the remaining text
$textGColor      = 0;
$textBColor      = 0;

// the next 3 values set where the "Invoice to" block will print on the page
$leftOffset      = 45;      // offset from left margin 
$invoiceInfo     = 575;     // absolute up/down position
$leftIndent      = $leftOffset + 15;    // how far to indent the text UNDER "Invoice To"

//
//  query the database for the invoiced company address
//
$q = new w2p_Database_Query();
$q->addQuery(' 
        company_name, 
        company_address1, 
        company_address2,
        company_city,
        company_state,
        company_zip,
        company_phone1,
        company_fax');
$q->addTable('companies');
$q->leftJoin('projects', 'p', 'project_company = company_id');
$q->addWhere('p.project_id = ' . $project_id);
//$targComp = $q->loadHash();
$targComp = $q->loadHash(); //db_loadHash($q->prepare(), $targComp);
    

//
// Set up and print the addressed to block
//
$pdf->setColor($toRColor,$toGColor,$toBColor);
$pdf->ezText('Invoice To:', $toFontSize, array('aleft' =>
$leftOffset)); 
$pdf->ezSetY($invToInfoPos);
$pdf->setColor(0,0,0);
$pdf->ezText($targComp['company_name'], $addressFontSize, array('aleft' => $leftIndent));
$pdf->ezText($targComp['company_address1'], $addressFontSize, array('aleft' => $leftIndent));

if ($targComp['company_address2'] != '')
	$pdf->ezText($targComp['company_address2'], $addressFontSize, array('aleft' => $leftIndent));

$pdf->ezText($targComp['company_city'] . ', ' .
$targComp['company_state'] . '   ' .
$targComp['company_zip'], $addressFontSize, array('aleft' =>
$leftIndent));

//================================================
//  Main invoice info
//================================================
$pdf->ezSetY($invToInfoPos);

// positions and prints the invoice number, date etc
$fontSize   = 12;
$xpos       = 0;    // holds the position of the last up/down print
$aleftText  = 350;  // position from left margin to the left of text position
$aleftInfo  = $aleftText + 100; //  position from left margin to left of data position

// $invoiceInfo sets the up/down position to start printing
$pdf->ezSetY( $invoiceInfo );

// print invoice number
$pdf->ezText( "Invoice Number:", $fontSize, array('aleft' => $aleftText  ));
$pdf->ezSetY( $invoiceInfo );

// print invoice date
$xpos = $pdf->ezText( $invoice_id, $fontSize, array('aleft' => $aleftInfo ));
$date = new w2p_Utilities_Date();
$pdf->ezSetY( $xpos );
$pdf->ezText( 'Invoice Date:', $fontSize, array('aleft' => $aleftText ));
$pdf->ezSetY( $xpos );
$xpos = $pdf->ezText($date->format( $df ) , $fontSize, array('aleft' => $aleftInfo ));

// print invoice terms
$pdf->ezText( 'Invoice Terms:', $fontSize, array('aleft' => $aleftText ));
$pdf->ezSetY( $xpos );
$pdf->ezText('Due Upon Receipt' , $fontSize, array('aleft' => $aleftInfo ));
$pdf->ezSetY( $invoiceInfo - 125 );

//================================================
//  Invoice details table
//================================================
//  set up the header array
$pdfheaders3 = array(
    'Date',
    'Description',
    'Price',
    'Hours',
    'Amount');

//--  get some data
$q = new w2p_Database_Query();
$q->addQuery('task_amount');
$q->addQuery('invoice_task_queue.task_log_id');
$q->addQuery('task_log_description');
$q->addQuery('task_log_date');
$q->addQuery('task_log_hours');
$q->addQuery('task_log_costcode');
$q->addQuery('billingcode_value');

$q->addTable('invoice_task_queue');
$q->addTable('task_log');
$q->leftJoin('billingcode', 'b', 'b.billingcode_id = task_log_costcode');

$q->addWhere('task_invoice = ' . $invoice_id);
$q->addWhere('task_log.task_log_id = invoice_task_queue.task_log_id');
//$q->addWhere('billingcode.billingcode_id = task_log_costcode');

$pname = $q->loadList();
// create the array needed by ezTable 
$pdfdata = array();
$invTotal = 0;
$hoursTotal = 0;

foreach ($pname as $inv) {
    $d = new w2p_Utilities_Date($inv['task_log_date']); 
    if ($inv['task_amount'] > 0)
			$amt = $inv['task_amount'];
		else
			$amt = round($inv['billingcode_value'] * $inv['task_log_hours'], 2);
    $dispAmt = w2PgetConfig('currency_symbol') . sprintf("%.2f", $amt, 2);
    $invTotal = $invTotal + $amt;
		$hoursTotal += $inv['task_log_hours'];
    
    $pdfdata[] = array(
        $d->format($df),
        $inv['task_log_description'],
        (($inv['task_amount'] > 0)?'set':(w2PgetConfig('currency_symbol').sprintf("%.2f",$inv['billingcode_value'], 2))),
        sprintf("%.2f", $inv['task_log_hours'], 2),
        $dispAmt    );
    }

// define the options for the table
$options = array(
            'showLines' => 1,
            'showHeadings' => 1,
            'fontSize' => 8,
            'rowGap' => 2,
            'colGap' => 5,
            'xPos' => 50,
            'xOrientation' => 'right',
            'width'=>'527',
           
'cols'=>array(
				0=>array('justification'=>'left','width'=>50),
				1=>array('justification'=>'left','width'=>150),
				2=>array('justification'=>'center','width'=>75),
				3=>array('justification'=>'center','width'=>75),
				4=>array('justification'=>'center','width'=>75))
			);

// print the table
$pdf->ezTable( $pdfdata, $pdfheaders3,'',$options );
$pdf->ezText('');
$pdf->ezText('');

// print the invoice total
$pdf->ezText("Total hours:           " . sprintf("%.2f",$hoursTotal), 12,
array('justification'=>'right'));
$pdf->ezText("Invoice Total:	  " . w2PgetConfig('currency_symbol').sprintf("%.2f",$invTotal,2), 12,
array('justification'=>'right'));

$options = array ( 
		'compress' => 0
		);

if (!isset($file))
	$pdf->ezStream(); 
else
{
$file = "$base_url/files/temp/temp_inv" . $AppUI->user_id . '.pdf';


if ($fp = fopen( "$temp_dir/temp_inv" . $AppUI->user_id . '.pdf', 'wb' )) {
		fwrite( $fp, $pdf->ezOutput() );
		fclose( $fp );
		echo "<HTML><SCRIPT>document.location='$file';</SCRIPT></HTML>";
    } 
	else {
		echo "Could not open file to save PDF.  ";
        if (!is_writable( $temp_dir )) {
			"The files/temp directory is not writable.  Check your file system permissions.";
        }
    }
}
?>
