<?php
/*
 * Name:      Invoice
 * Directory: invoice
 * Version:   0.5
 * Class:     user
 * UI Name:   Invoice
 * UI Icon:
 */

// MODULE CONFIGURATION DEFINITION
$config = array();
$config['mod_name'] = 'Invoice';
$config['mod_version'] = '0.6';
$config['mod_directory'] = 'invoice';
$config['mod_setup_class'] = 'CSetupInvoice';
$config['mod_type'] = 'user';
$config['mod_ui_name'] = $config['mod_name'];
$config['mod_ui_icon'] = 'applet3-48.png';
$config['mod_description'] = 'A module for billing tasks';
$config['mod_config'] = false;
$config['mod_main_class'] = 'CInvoice';

// permissions
$config['permission_item_table'] = 'invoice';    // table to check for permissions
$config['permission_item_field'] = 'invoice_id'; // primary key
$config['permission_item_field'] = 'invoice_tag';// administration number (eg: <yyyy><nn>)

if (@$a == 'setup') {
	echo w2PshowModuleConfig( $config );
}

class CSetupInvoice extends w2p_Core_Setup
{
	public function install() {
		$sql = "(
  `invoice_id` bigint(20) NOT NULL auto_increment,
  `invoice_tag` char(10) NOT NULL unique,
  `invoice_project` int(11) NOT NULL default '0',
  `invoice_status` int(4) NOT NULL default '0',
  `invoice_date` int(11) NOT NULL default '0',
  `invoice_paid` int(11) default NULL,
  `invoice_creator` int(11) NOT NULL default '0',
  PRIMARY KEY  (`invoice_id`)
) TYPE=MyISAM ";
		$q = new w2p_Database_Query();
		$q->createTable('invoice');
		$q->createDefinition($sql);
		$q->exec();
		$sql = "(
  `task_queue_id` int(11) NOT NULL auto_increment,
  `task_invoice` int(11) NOT NULL default '0',
  `task_amount` float NOT NULL default '0',
  `task_log_id` bigint(20) NOT NULL default '0',
  PRIMARY KEY  (`task_queue_id`)
) TYPE=MyISAM ";
		$q->clear();
		$q->createTable('invoice_task_queue');
		$q->createDefinition($sql);
		$q->exec();
		return parent::install();
	}
	
	public function remove() {
		$q = new w2p_Database_Query();

		$q->dropTable('invoice');
		$q->exec();
		$q->clear();

		$q->dropTable('invoice_task_queue');
		$q->exec();	
		
		return parent::remove();
	}
	
	public function upgrade($old_version) {
                switch ($old_version) {
                case 0.1:
                default:
                    return true;
                }
		return false;
	}
}

?>	

